﻿using System;
using System.Text;
using Blend.xPlatform;
using Blend.xPlatform.Win32;

namespace AsciiDrawerExample
{
    class Program
    {
        const int maxWidth = 80;
        const int maxHeight = 40;

        static void draw(string fileName)
        {
            msvcrt.system("cls");
            char[,] buffer = new char[maxWidth, maxHeight];
            IntPtr stream = msvcrt.fopen(fileName, "rt");

            if (stream == IntPtr.Zero)
            {
                msvcrt.fprintf(msvcrt.stderr, "Invalid - or - not existing file name.\n");
                msvcrt.exit(-1);
            }

            msvcrt.fprintf(msvcrt.stdout, "\n");
            int coordX = 0, coordY = 0, charIndex = 0, maxCoordY = 0;

            while (msvcrt.feof(stream) == 0)
            {
                msvcrt.fscanf(stream, "%d %d %d", __arglist(ref coordX, ref coordY, ref charIndex));

                if (coordX < maxWidth && coordY < maxHeight &&
                    charIndex > (-1) && charIndex < 256)
                {
                    maxCoordY = msvcrt.max<int>(maxCoordY, coordY);
                    buffer[coordX, coordY] = (char)charIndex;
                }
            }

            if (maxCoordY != maxHeight)
                maxCoordY++;

            msvcrt.fclose(stream);
            stream = IntPtr.Zero;

            for (int y = 0; y < maxCoordY; y++)
            {
                for (int x = 0; x < maxWidth; x++)
                    msvcrt.putc((int)buffer[x, y], msvcrt.stdout);
            }

            msvcrt.printf("\n\n");
        }

        static void Main()
        {
            try
            {
                msvcrt.system("chcp 437");
                msvcrt.system("cls");

                while (true)
                {
                    for (int i = 0; i < 8; i++)
                    {
                        draw(String.Format("run{0}.txt", i + 1));
                        msvcrt._sleep(800);
                    }
                }
            }
            catch (Exception throwedException)
            {
                Console.Error.WriteLine(throwedException.ToString());
                msvcrt._exit(0);
            }
        }
    }
}
