/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 *  ̺귯  ƮԴϴ. Ʈ Ǿ絵ڴ  Ʈ 
 * ǥ GNU  Ϲ   㰡 2.1 Ǵ    Ƿ ؼ,  
 *  ̺귯 ϰų   ֽϴ.
 * 
 *  ̺귯 ϰ     ǰ , Ư 
 * ´ ռ γ Ǹſ        
 *   ʽϴ.  ڼ ׿ ؼ GNU  Ϲ   㰡
 * Ͻñ ٶϴ.
 * 
 * GNU  Ϲ   㰡  ̺귯 Բ ˴ϴ. ,   
 * Ǿִٸ  Ʈ  Ͻñ ٶϴ.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.ComponentModel;
using System.Collections.Generic;

namespace Blend
{
    [Serializable()]
    public class QuickSort<T> : SortBase<T>
        where T: IComparable<T>, IComparable
    {
        [NonSerialized()]
        public const int DefaultQuickSortStackSize = 64;

        public QuickSort()
            : base()
        {
        }

        public QuickSort(int nInternalStackSize)
            : this()
        {
            this.InternalStackSize = nInternalStackSize;
        }

        public QuickSort(IList<T> oList)
            : base(oList)
        {
        }

        public QuickSort(int nInternalStackSize, IList<T> oList)
            : this(oList)
        {
            this.InternalStackSize = nInternalStackSize;
        }

        public QuickSort(params T[] oArray)
            : base(oArray)
        {
        }

        public QuickSort(int nInternalStackSize, params T[] oArray)
            : this(oArray)
        {
            this.InternalStackSize = nInternalStackSize;
        }

        private int m_nInternalStackSize = DefaultQuickSortStackSize;

        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public int InternalStackSize
        {
            get { return this.m_nInternalStackSize; }
            set { this.m_nInternalStackSize = (value < DefaultQuickSortStackSize) ? DefaultQuickSortStackSize : value; }
        }

        public override void SortInternal(bool reverse)
        {
            if (this.Count < 1)
                return;

            int lo = 0, hi = this.Count - 1, mid, loguy, higuy, stkptr = 0;
            int[] lostk = new int[this.m_nInternalStackSize];
            int[] histk = new int[this.m_nInternalStackSize];
            T temp;

            while (true)
            {
                mid = lo + (((hi - lo) + 1) / 2);

                temp = this[mid];
                this[mid] = this[lo];
                this[lo] = temp;

                loguy = lo;
                higuy = hi + 1;

                while (true)
                {
                    do loguy++;
                    while (loguy <= hi && !this.InternalComparer(this[loguy], this[lo], reverse, true));

                    do higuy--;
                    while (higuy > lo && this.InternalComparer(this[higuy], this[lo], reverse, true));

                    if (higuy < loguy)
                        break;

                    temp = this[loguy];
                    this[loguy] = this[higuy];
                    this[higuy] = temp;
                }

                temp = this[lo];
                this[lo] = this[higuy];
                this[higuy] = temp;

                if (higuy - 1 - lo >= hi - loguy)
                {
                    if (lo + 1 < higuy)
                    {
                        lostk[stkptr] = lo;
                        histk[stkptr] = higuy - 1;
                        ++stkptr;
                    }

                    if (loguy < hi)
                    {
                        lo = loguy;
                        continue;
                    }
                }
                else
                {
                    if (loguy < hi)
                    {
                        lostk[stkptr] = loguy;
                        histk[stkptr] = hi;
                        ++stkptr;
                    }

                    if (lo + 1 < higuy)
                    {
                        hi = higuy - 1;
                        continue;
                    }
                }

                --stkptr;

                if (stkptr >= 0)
                {
                    lo = lostk[stkptr];
                    hi = histk[stkptr];
                }
                else
                    break;
            }
        }
    }
}
