﻿/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 * 이 라이브러리는 자유 소프트웨어입니다. 소프트웨어의 피양도자는 자유 소프트웨어 재단이
 * 공표한 GNU 약소 일반 공중 사용 허가서 2.1판 또는 그 이후 판을 임의로 선택해서, 그 규정에
 * 따라 라이브러리를 개작하거나 재배포할 수 있습니다.
 * 
 * 이 라이브러리는 유용하게 사용될 수 있으리라는 희망에서 배포되고 있지만, 특정한 목적에
 * 맞는 적합성 여부나 판매용으로 사용할 수 있으리라는 묵시적인 보증을 포함한 어떠한 형태의
 * 보증도 제공하지 않습니다. 보다 자세한 사항에 대해서는 GNU 약소 일반 공중 사용 허가서를
 * 참고하시기 바랍니다.
 * 
 * GNU 약소 일반 공중 사용 허가서는 이 라이브러리와 함께 제공됩니다. 만약, 이 문서가 누락
 * 되어있다면 자유 소프트웨어 재단으로 문의하시기 바랍니다.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.Collections.Generic;

namespace Blend.Sortings
{
    public class PermSort<T> : SortBase<T>
        where T: IComparable<T>, IComparable
    {
        public PermSort()
            : base()
        {
        }

        public PermSort(IList<T> oList)
            : base(oList)
        {
        }

        public PermSort(params T[] oArray)
            : base(oArray)
        {
        }

        protected bool IsSorted(int i, bool reverse)
        {
            for (int j = this.Count - 1; j > 0; j--)
                if (!this.InternalComparer(this[j], this[j - 1], reverse))
                    return false;

            return true;
        }

        protected bool __SortInternal(int i, bool reverse)
        {
            if (this.IsSorted(i, reverse))
                return true;

            T obj = default(T);

            for (int j = i + 1; j < this.Count; j++)
            {
                obj = this[i];
                this[i] = this[j];
                this[j] = obj;

                if (this.__SortInternal(i + 1, reverse))
                    return true;

                obj = this[i];
                this[i] = this[j];
                this[j] = obj;
            }

            return false;
        }

        protected override void SortInternal(bool reverse)
        {
            this.__SortInternal(0, reverse);
        }
    }
}
