﻿/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 * 이 라이브러리는 자유 소프트웨어입니다. 소프트웨어의 피양도자는 자유 소프트웨어 재단이
 * 공표한 GNU 약소 일반 공중 사용 허가서 2.1판 또는 그 이후 판을 임의로 선택해서, 그 규정에
 * 따라 라이브러리를 개작하거나 재배포할 수 있습니다.
 * 
 * 이 라이브러리는 유용하게 사용될 수 있으리라는 희망에서 배포되고 있지만, 특정한 목적에
 * 맞는 적합성 여부나 판매용으로 사용할 수 있으리라는 묵시적인 보증을 포함한 어떠한 형태의
 * 보증도 제공하지 않습니다. 보다 자세한 사항에 대해서는 GNU 약소 일반 공중 사용 허가서를
 * 참고하시기 바랍니다.
 * 
 * GNU 약소 일반 공중 사용 허가서는 이 라이브러리와 함께 제공됩니다. 만약, 이 문서가 누락
 * 되어있다면 자유 소프트웨어 재단으로 문의하시기 바랍니다.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.Text;
using System.Security.Permissions;
using System.Runtime.InteropServices;

namespace Blend.xPlatform.Linux
{
    // Full Reference: http://www.gnu.org/software/libc/manual/html_mono/libc.html

    partial class libc
    {
        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr fopen(string fileName, string mode);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void fclose(IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int fputs(string str, IntPtr stream);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strerror(int errnum);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr strerror_r(int errnum, StringBuilder buf, size_t n);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void perror(string message);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void error(int status, int errnum, string format);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void error(int status, int errnum, string format, __arglist);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void error_at_line(int status, int errnum, string fname, uint lineno, string format);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void error_at_line(int status, int errnum, string fname, uint lineno, string format, __arglist);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void warn(string format, __arglist);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void warn(string format);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void vwarn(string format, IntPtr va_list);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void warnx(string format, __arglist);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void warnx(string format);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void vwarnx(string format, IntPtr va_list);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void err(int status, string format, __arglist);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void err(int status, string format);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void verr(int status, string format, IntPtr va_list);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void errx(int status, string format, __arglist);

        [DllImport(ModuleName, CallingConvention = CallingConvention.Cdecl)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void errx(int status, string format);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void verrx(int status, string format, IntPtr va_list);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr malloc(size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void free(IntPtr ptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void cfree(IntPtr ptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr realloc(IntPtr ptr, size_t newsize);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr calloc(size_t count, size_t eltsize);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr memalign(size_t boundary, size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int posix_memalign(IntPtr memptr, size_t alignment, size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr valloc(size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int mallopt(int param, int value);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int mcheck(abortfn abortfn);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int mprobe(IntPtr pointer);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern mallinfo mallinfo();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void mtrace();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void muntrace();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int obstack_init(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr obstack_alloc(IntPtr obstackptr, int size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr obstack_copy(IntPtr obstackptr, IntPtr address, int size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr obstack_copy0(IntPtr obstackptr, IntPtr address, int size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_free(IntPtr obstackptr, IntPtr @object);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_blank(IntPtr obstackptr, int size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_grow(IntPtr obstackptr, IntPtr data, int size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_grow0(IntPtr obstackptr, IntPtr data, int size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_1grow(IntPtr obstackptr, byte c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_ptr_grow(IntPtr obstackptr, IntPtr data);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_int_grow(IntPtr obstackptr, int data);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr obstack_finish(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int obstack_object_size(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int obstack_room(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_1grow_fast(IntPtr obstackptr, byte c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_ptr_grow_fast(IntPtr obstackptr, IntPtr data);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_int_grow_fast(IntPtr obstackptr, int data);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern void obstack_blank_fast(IntPtr obstackptr, int size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr obstack_base(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr obstack_next_free(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int obstack_alignment_mask(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int obstack_chunk_size(IntPtr obstackptr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr alloca(size_t size);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int brk(IntPtr addr);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern IntPtr sbrk(ptrdiff_t delta);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int mlock(IntPtr addr, size_t len);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int munlock(IntPtr addr, size_t len);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int mlockall(int flags);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int munlockall();

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int islower(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isupper(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isalpha(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isdigit(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isalnum(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isxdigit(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int ispunct(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isspace(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isblank(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isgraph(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isprint(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int iscntrl(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int isascii(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int tolower(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int toupper(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int toascii(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _tolower(int c);

        [DllImport(ModuleName)]
        [SecurityPermission(SecurityAction.LinkDemand)]
        public static extern int _toupper(int c);
    }
}
