﻿/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 * 이 라이브러리는 자유 소프트웨어입니다. 소프트웨어의 피양도자는 자유 소프트웨어 재단이
 * 공표한 GNU 약소 일반 공중 사용 허가서 2.1판 또는 그 이후 판을 임의로 선택해서, 그 규정에
 * 따라 라이브러리를 개작하거나 재배포할 수 있습니다.
 * 
 * 이 라이브러리는 유용하게 사용될 수 있으리라는 희망에서 배포되고 있지만, 특정한 목적에
 * 맞는 적합성 여부나 판매용으로 사용할 수 있으리라는 묵시적인 보증을 포함한 어떠한 형태의
 * 보증도 제공하지 않습니다. 보다 자세한 사항에 대해서는 GNU 약소 일반 공중 사용 허가서를
 * 참고하시기 바랍니다.
 * 
 * GNU 약소 일반 공중 사용 허가서는 이 라이브러리와 함께 제공됩니다. 만약, 이 문서가 누락
 * 되어있다면 자유 소프트웨어 재단으로 문의하시기 바랍니다.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.Text;
using Blend.Sortings;
using System.Reflection;
using Blend.xPlatform.Win32;
using System.Reflection.Emit;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Blend.xPlatform.Test
{
    class Program
    {
        [DllImport("kernel32.dll", CharSet = CharSet.Ansi, ExactSpelling = true)]
        internal static extern IntPtr LoadLibraryA(string lpFileName);

        [DllImport("kernel32.dll", CharSet = CharSet.Ansi, ExactSpelling = true)]
        internal static extern IntPtr GetProcAddress(IntPtr hModule, string procName);

        [DllImport("kernel32.dll", SetLastError = true)]
        internal static extern bool FreeLibrary(IntPtr hModule);

        public static void Main(string[] args)
        {
            //CustomDelegateTest();
            //Console.ReadLine();
            //ConversionTest();
            //Console.ReadLine();
            //PointerAndStdHandleTest();
            //Console.ReadLine();

            //SortTest<Sortings.BubbleSort<int>>(false);
            //SortTest<Sortings.BubbleSort<int>>(true);
            //SortTest<Sortings.InsertionSort<int>>(false);
            //SortTest<Sortings.InsertionSort<int>>(true);
            //SortTest<Sortings.NewQuickSort<int>>(false);
            //SortTest<Sortings.NewQuickSort<int>>(true);
            //SortTest<Sortings.QuickSort<int>>(false);
            //SortTest<Sortings.QuickSort<int>>(true);
            //SortTest<Sortings.SelectionSort<int>>(false);
            //SortTest<Sortings.SelectionSort<int>>(true);
            //SortTest<Sortings.ShellSort<int>>(false);
            //SortTest<Sortings.ShellSort<int>>(true);
            //SortTest<Sortings.ShakerSort<int>>(false);
            //SortTest<Sortings.ShakerSort<int>>(true);
            //SortTest<Sortings.NewShakerSort<int>>(false);
            //SortTest<Sortings.NewShakerSort<int>>(true);
            //SortTest<Sortings.StoogeSort<int>>(false);
            //SortTest<Sortings.StoogeSort<int>>(true);
            //SortTest<Sortings.HeapSort<int>>(false);
            //SortTest<Sortings.HeapSort<int>>(true);
            //SortTest<Sortings.CocktailSort<int>>(false);
            //SortTest<Sortings.CocktailSort<int>>(true);
            //SortTest<Sortings.BozoSort<int>>(false);
            //SortTest<Sortings.BozoSort<int>>(true);
            //SortTest<Sortings.JSort<int>>(false);
            //SortTest<Sortings.JSort<int>>(true);
            //SortTest<Sortings.QMSort<int>>(false);
            //SortTest<Sortings.QMSort<int>>(true);
            //SortTest<Sortings.MergeSort<int>>(false);
            //SortTest<Sortings.MergeSort<int>>(true);
            //SortTest<Sortings.PermSort<int>>(false);
            //SortTest<Sortings.PermSort<int>>(true);
        }

        static void SortTest<T>(bool reverse)
            where T: SortBase<int>
        {
            Console.WriteLine("{0} {1}", typeof(T).ToString(), reverse ? "(Descending)" : "(Ascending)");
            Random random = new Random();
            T randomTimes = Activator.CreateInstance<T>();

            for (int i = 0; i < 10; i++)
                randomTimes.Add(random.Next());

            randomTimes.Sort(reverse);

            foreach (int eachElem in randomTimes)
                Console.WriteLine(eachElem.ToString());

            Console.ReadLine();
        }

        static void CustomDelegateTest()
        {
            DynamicTypeServices dac = new DynamicTypeServices();
            IntPtr ptr = LoadLibraryA("msvcrt.dll");
            IntPtr func = GetProcAddress(ptr, "printf");
            Delegate printf = dac.CreateCustomDelegate(func, null, typeof(int), typeof(string), typeof(int));

            for (int i = 0; i < 123; i++)
                printf.DynamicInvoke("%d\r\n", i);

            FreeLibrary(ptr);
        }

        static void ConversionTest()
        {
            DynamicTypeServices dac = new DynamicTypeServices();
            Type t = dac.BuildStructureType(typeof(FILE));
            t = dac.BuildStructureType(typeof(FILE));
            Console.WriteLine(t.FullName);
            FieldInfo[] fields = t.GetFields();

            for (int i = 0; i < fields.Length; i++)
                Console.WriteLine("{0} {1}", fields[i].FieldType.ToString(), fields[i].Name);
        }

        static void PointerAndStdHandleTest()
        {
            Console.WriteLine("Warning! This test should run out of the VSHOST debugging environment!");
            AddressWalker32 aw32 = msvcrt.__p__iob();
            aw32.SelectFrameSize(typeof(FILE));
            int count = 0;

            for (int i = 0; i < 6; i++)
            {
                msvcrt.fprintf(
                    msvcrt.stdout,
                    @"
    * STDIN Address: %d
    * STDOUT Address: %d
    * STDERR Address: %d
          via STDOUT with ANSI!

",
                    __arglist(
                        aw32[msvcrt.STDIN_FILENO].ToInt32(),
                        aw32[msvcrt.STDOUT_FILENO].ToInt32(),
                        aw32[msvcrt.STDERR_FILENO].ToInt32())
                );

                msvcrt.fprintf(
                    msvcrt.stderr,
                    @"    * STDIN Address: %-2d
    * STDOUT Address: %-2d
    * STDERR Address: %-2d
          via STDERR with ANSI!

",
                    __arglist(
                        aw32[msvcrt.STDIN_FILENO].ToInt32(),
                        aw32[msvcrt.STDOUT_FILENO].ToInt32(),
                        aw32[msvcrt.STDERR_FILENO].ToInt32())
                );
            }

            foreach (IntPtr eachPtr in aw32)
            {
                if (count.Equals(3))
                    return;

                msvcrt.fprintf(msvcrt.stdout, "\t%s\r\n", __arglist(aw32[count].Equals(eachPtr).ToString()));
                count++;
            }
        }
    }
}
