﻿/*
 * Project Blend: the Blossom of .NET Development
 * Copyright (c) 2007 Project Blend
 * 
 * 이 라이브러리는 자유 소프트웨어입니다. 소프트웨어의 피양도자는 자유 소프트웨어 재단이
 * 공표한 GNU 약소 일반 공중 사용 허가서 2.1판 또는 그 이후 판을 임의로 선택해서, 그 규정에
 * 따라 라이브러리를 개작하거나 재배포할 수 있습니다.
 * 
 * 이 라이브러리는 유용하게 사용될 수 있으리라는 희망에서 배포되고 있지만, 특정한 목적에
 * 맞는 적합성 여부나 판매용으로 사용할 수 있으리라는 묵시적인 보증을 포함한 어떠한 형태의
 * 보증도 제공하지 않습니다. 보다 자세한 사항에 대해서는 GNU 약소 일반 공중 사용 허가서를
 * 참고하시기 바랍니다.
 * 
 * GNU 약소 일반 공중 사용 허가서는 이 라이브러리와 함께 제공됩니다. 만약, 이 문서가 누락
 * 되어있다면 자유 소프트웨어 재단으로 문의하시기 바랍니다.
 * 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * Korean Translation Comes from: http://korea.gnu.org/people/chsong/copyleft/lgpl.ko.html
 * */

using System;
using System.Text;
using Blend.xPlatform.Win32;

/*
// Original C Language Code

#define MAX_COLS 32768

int main() {
  FILE *in;
  char s[MAX_COLS]; // 행이 1줄씩 임시로 저장될 버퍼

  // fopen() 함수로 파일 열기
  if ( (in = fopen("C:\\WINDOWS\\UPGRADE.TXT", "rt")) == NULL) {
    fputs("Cannot open input file...\n", stderr);
    printf("Press any key to continue...");
    getc(stdin);
    exit(1); // 모든 파일 닫고, 프로그램 종료
  }

  // 읽기 시작: 프로그램의 본체
  while (fgets(s, MAX_COLS, in) != NULL) {
    printf(s); // 한 줄씩 화면에 출력
  }

  fcloseall(); // 모든 파일 닫기
  printf("Press any key to continue...");
  getc(stdin);
  return 0;
}
*/

namespace FileIoExample
{
    class Program
    {
        // xPlatform에서 제공하는 API로 위의 C 언어 코드를 재구성하였습니다.
        // C 언어 코드 거의 그대로를 C#으로 일정 수준 이상 번역하여 사용할 수 있으므로
        // 다양한 방법을 통하여 기존의 C 코드와의 상호 연동 가능성을 향상시킬 수 있습니다.
        const int MAX_COLS = 32768;

        static int Main() {
            IntPtr @in;
            StringBuilder s = new StringBuilder(MAX_COLS); // 행이 1줄씩 임시로 저장될 버퍼

            // fopen() 함수로 파일 열기
            if ((@in = msvcrt.fopen("C:\\WINDOWS\\UPGRADE.TXT", "rt")) == IntPtr.Zero) {
                msvcrt.fputs("Cannot open input file...\r\n", msvcrt.stderr);
                msvcrt.printf("Press any key to continue...");
                msvcrt.getc(msvcrt.stdin);
                msvcrt.exit(1);
            }

            // 읽기 시작: 프로그램의 본체
            while (msvcrt.fgets(s, MAX_COLS, @in) != IntPtr.Zero) {
                msvcrt.printf(s.ToString());
            }

            msvcrt._fcloseall(); // 모든 파일 닫기
            msvcrt.printf("Press any key to continue...");
            msvcrt.getc(msvcrt.stdin);
            return 0;
        }
    }
}
